<?php

namespace AMZcockpitDoctrine\Repository;

use AMZcockpitDoctrine\Entity\MWS\Store;
use Symfony\Component\Intl\Intl;

/**
 * UserRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class UserRepository extends \Doctrine\ORM\EntityRepository
{
    /**
     * @return array
     */
    public function findByRole($role,$results = true)
    {
        $qb = $this->createQueryBuilder('u')
            ->andWhere('u.roles LIKE :role')
            ->setParameter('role', '%"'.$role.'"%')
            ->orderBy('u.createdAt', 'desc')
        ;
        if($results)
            return $qb->getQuery()->getResult();
        return $qb;
    }

    /**
     * @return array
     */
    public function getUnsubscribedUsers()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->where($qb->expr()->isNotNull('u.unsubscribeDate'))
            ->andWhere($qb->expr()->lte('u.unsubscribeDate',':nowDate'))
            ->andWhere($qb->expr()->eq('u.unsubscribeNotified',':unsubscribeNotified'))
            ->setParameter('nowDate', new \DateTime('now'))
            ->setParameter('unsubscribeNotified', false)
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getActiveUsers()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere(($qb->expr()->eq('s.validated',':validated')))
            ->setParameter('validated',true);

        $qb->addOrderBy('u.id','DESC');
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersEmptyStore()
    {
        $date = new \DateTime('now');
        $date->sub(new \DateInterval('PT48H'));

        $dateMin = new \DateTime('now');
        $dateMin->sub(new \DateInterval('P4D'));
        $qb = $this->createQueryBuilder('u');
        $qb->select('u')
            ->leftJoin('u.stores','s')
            ->where($qb->expr()->isNull('s.id'))
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->eq('u.notifEmptyStore',':notifEmptyStore'),
                    $qb->expr()->isNull('u.notifEmptyStore')
                )
            )
            ->setParameter('notifEmptyStore',false)
            ->andWhere($qb->expr()->lte('u.createdAt',':createdAt'))
            ->setParameter('createdAt',$date)
            ->andWhere($qb->expr()->gte('u.createdAt',':createdAtMin'))
            ->setParameter('createdAtMin',$dateMin);

        $qb->addOrderBy('u.id','DESC');
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersNewsStoreTrialElapse()
    {
        $date = new \DateTime('now');
        $date->sub(new \DateInterval('P4D'));

        $dateMax = new \DateTime('now');
        $dateMax->sub(new \DateInterval('P6D'));

        $qb = $this->createQueryBuilder('u');
        $qb->select('u')
            ->leftJoin('u.stores','s')
            ->where($qb->expr()->isNotNull('s.id'))
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->eq('u.notifTrialElapsePoke',':notifTrialElapsePoke'),
                    $qb->expr()->isNull('u.notifTrialElapsePoke')
                )
            )
            ->setParameter('notifTrialElapsePoke',false)
            ->andWhere($qb->expr()->lte('u.createdAt',':createdAt'))
            ->setParameter('createdAt',$date)
            ->andWhere($qb->expr()->gte('u.createdAt',':createdAtMin'))
            ->setParameter('createdAtMin',$dateMax);

        $qb->addOrderBy('u.id','DESC');
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getActivePPCUsers()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->select('u')
            ->where($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere("u.refresh_token != ''")
            ->andWhere("u.refresh_token IS NOT NULL")
            ->andWhere("u.access_token != ''")
            ->andWhere("u.access_token IS NOT NULL");
            
        $qb->addOrderBy('u.id','ASC');
        return $qb->getQuery()->getResult();
    }

    public function findByEmail($email)
    {
        $qb = $this->createQueryBuilder('u');
            $qb->select('u')
                ->where($qb->expr()->eq('u.email',':email'))
                ->setParameter('email',$email) ;           

            return $qb->getQuery()->getResult();
    }


    /**
     * @return array
     */
    public function getUserToSearchReviews()
    {
        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('PT24H'));

        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere($qb->expr()->eq('u.processReviews',':processReviews'))
            ->setParameter('processReviews',false)

            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->lt('u.lastProcessReviewsExecutionDate',':lastProcessReviewsExecutionDate'),
                    $qb->expr()->isNull('u.lastProcessReviewsExecutionDate')
                )
            )
            ->setParameter('lastProcessReviewsExecutionDate',$dateLastExec)
            ->setMaxResults(1)
            ->orderBy('u.lastProcessReviewsExecutionDate','ASC');
        ;
        return $qb->getQuery()->getOneOrNullResult();
    }

    /**
     * @return array
     */
    public function getUserToFetchFees()
    {
        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('PT24H'));

        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere($qb->expr()->eq('u.processFees',':processFees'))
            ->setParameter('processFees',false)

            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->lt('u.lastFeesDate',':lastFeesDate'),
                    $qb->expr()->isNull('u.lastFeesDate')
                )
            )
            ->setParameter('lastFeesDate',$dateLastExec)
            ->setMaxResults(1)
        ;
        return $qb->getQuery()->getOneOrNullResult();
    }

    /**
     * @return array
     */
    public function getUserToFetchOrders()
    {
        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('PT2H'));

        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere($qb->expr()->eq('u.processStoresUpdate',':processStoresUpdate'))
            ->setParameter('processStoresUpdate',false)
            ->orderBy('u.lastStoresUpdate','ASC')
            ->addOrderBy('u.id','DESC')

            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->lt('u.lastStoresUpdate',':lastStoresUpdate'),
                    $qb->expr()->isNull('u.lastStoresUpdate')
                )
            )
            ->setParameter('lastStoresUpdate',$dateLastExec)
            ->setMaxResults(1)
        ;
        return $qb->getQuery()->getSingleResult();
    }

    /**
     * @return array
     */
    public function getUsersToFetchOrders()
    {
        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('PT2H'));

        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere($qb->expr()->eq('u.processStoresUpdate',':processStoresUpdate'))
            ->setParameter('processStoresUpdate',false)
            ->orderBy('u.lastStoresUpdate','ASC')
            ->addOrderBy('u.id','DESC')

            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->lt('u.lastStoresUpdate',':lastStoresUpdate'),
                    $qb->expr()->isNull('u.lastStoresUpdate')
                )
            )
            ->setParameter('lastStoresUpdate',$dateLastExec)
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUserToFetchFeedbacks()
    {
        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('PT24H'));

        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere($qb->expr()->eq('u.processFeedbacks',':processFeedbacks'))
            ->setParameter('processFeedbacks',false)
            ->orderBy('u.lastFeedbacksUpdate','ASC')
            ->addOrderBy('u.id','DESC')

            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->lt('u.lastFeedbacksUpdate',':lastFeedbacksUpdate'),
                    $qb->expr()->isNull('u.lastFeedbacksUpdate')
                )
            )
            ->setParameter('lastFeedbacksUpdate',$dateLastExec)
            ->setMaxResults(1)
        ;
        return $qb->getQuery()->getOneOrNullResult();
    }

    /**
     * @return array
     */
    public function getUserToFetchProducts()
    {
        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('P3D'));

        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere($qb->expr()->eq('u.processProducts',':processProducts'))
            ->setParameter('processProducts',false)
            ->orderBy('u.lastProductsUpdateDate','ASC')
            ->addOrderBy('u.id','DESC')

            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->lt('u.lastProductsUpdateDate',':lastProductsUpdateDate'),
                    $qb->expr()->isNull('u.lastProductsUpdateDate')
                )
            )
            ->setParameter('lastProductsUpdateDate',$dateLastExec)
            ->setMaxResults(1)
        ;
        return $qb->getQuery()->getOneOrNullResult();
    }

    /**
     * @return array
     */
    public function getUserToFetchInventory()
    {
        $dateLastExec = new \DateTime('now');
        $dateLastExec->sub(new \DateInterval('PT24H'));

        $qb = $this->createQueryBuilder('u');
        $qb->leftJoin('u.stores','s');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere($qb->expr()->eq('u.processInventory',':processInventory'))
            ->setParameter('processInventory',false)
            ->orderBy('u.lastInventoryUpdate','ASC')
            ->addOrderBy('u.id','DESC')

            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->lt('u.lastInventoryUpdate',':lastInventoryUpdate'),
                    $qb->expr()->isNull('u.lastInventoryUpdate')
                )
            )
            ->setParameter('lastInventoryUpdate',$dateLastExec)
            ->setMaxResults(1)
        ;
        return $qb->getQuery()->getSingleResult();
    }


    /**
     * @return array
     */
    public function getPayUsersCount()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->select('COUNT(u) as _count, u.paymentYearly')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('u.hasCard',':hasCard'))
            ->setParameter('hasCard',true)
            ->andWhere($qb->expr()->eq('u.hasStores',':hasStores'))
            ->setParameter('hasStores',true)
            ->addGroupBy('u.paymentYearly')
        ;
        $return = ['yearly' => 0, 'monthly' => 0];
        $items = $qb->getQuery()->getResult();
        foreach ($items as $item) {
            if($item['paymentYearly']) {
                $return['yearly'] = $item['_count'];
            } else {
                $return['monthly'] = $item['_count'];
            }
        }
        return $return;
    }

    /**
     * @return array
     */
    public function getPayUsers()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->select('u')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('u.hasCard',':hasCard'))
            ->setParameter('hasCard',true)
            ->andWhere($qb->expr()->eq('u.hasStores',':hasStores'))
            ->setParameter('hasStores',true)
        ;
        return  $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersNeedToPay()
    {
        $qb = $this->createQueryBuilder('u');
        $qb
            ->select('u')
            ->distinct(true)
//            ->andWhere($qb->expr()->eq('u.hasCard',':hasCard'))
//            ->setParameter('hasCard',true)
            ->andWhere($qb->expr()->isNull('u.unsubscribeDate'))
            ->andWhere($qb->expr()->lte('u.paymentNextDate',':now'))
            ->setParameter('now',new \DateTime('now'))
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getAverageMonthlyPay()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->select('u.planId, COUNT(u.id) as _count, u.paymentYearly')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->isNull('u.unsubscribeDate'))
            ->andWhere($qb->expr()->eq('u.hasCard',':hasCard'))
            ->setParameter('hasCard',true)
            ->andWhere($qb->expr()->eq('u.hasStores',':hasStores'))
            ->setParameter('hasStores',true)
            ->groupBy('u.planId')
            ->addGroupBy('u.paymentYearly')
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getSubscriptionUsersCount()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->select('COUNT(u) as _count')
            ->addSelect('u.planId')
            ->addSelect('u.paymentYearly')
            ->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('u.hasCard',':hasCard'))
            ->setParameter('hasCard',true)
            ->andWhere($qb->expr()->eq('u.hasStores',':hasStores'))
            ->setParameter('hasStores',true)
        ;
        $qb->andWhere('u.planId IS NOT NULL');
        $qb->groupBy('u.planId')
        ->addGroupBy('u.paymentYearly');


        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersCountryRepartition()
    {
        $qb = $this->createQueryBuilder('u');
        $qb->select('COUNT(u) as gCount , u.pays as countryCode');
        $qb->groupBy('countryCode');

        $items = $qb->getQuery()->getResult();

        $unknownCountry = 0;
        $return = [];
        foreach ($items as $item) {
            if(is_null($item['countryCode'])) {
                $unknownCountry = $item['gCount'];
            } else {
                $return[] = [
                    'name'      => Intl::getRegionBundle()->getCountryName($item['countryCode']),
                    'code'      => $item['countryCode'],
                    'value'     => $item['gCount']
                ];
            }
        }

        return [
            'data' => $return,
            'unknownCountryUsersCount' => $unknownCountry
        ];

    }

    /**
     * @return array
     */
    public function getUsersCountByOrderCount($maxOrderCount = 100)
    {
        $qb = $this->createQueryBuilder('u');
        $qb->select('COUNT(u) as gCount');
        $qb->groupBy('countryCode');
        $qb->addSelect('DAY(o.purchaseDate) AS gDay, MONTH(o.purchaseDate) AS gDmonth, YEAR(o.purchaseDate) AS gDyear, AVG(COUNT(o.emailsJobs))');

        $items = $qb->getQuery()->getResult();

        $unknownCountry = 0;
        $return = [];
        foreach ($items as $item) {
            if(is_null($item['countryCode'])) {
                $unknownCountry = $item['gCount'];
            } else {
                $return[] = [
                    'name'      => Intl::getRegionBundle()->getCountryName($item['countryCode']),
                    'code'      => $item['countryCode'],
                    'value'     => $item['gCount']
                ];
            }
        }

        return [
            'data' => $return,
            'unknownCountryUsersCount' => $unknownCountry
        ];

    }

    public function getGainsLastYear() {

        $date = new \DateTime();
        $date->modify('-12 month');
        $mois = [ "Jan", "Fév", "Mar", "Avr", "Mai", "Juin", "Juil", "Aout", "Sep", "Oct", "Nov", "Déc" ];

        $qb = $this->createQueryBuilder('u');
        $date->setDate($date->format('Y'), $date->format('m') , 1);
        $date->setTime(0, 0,0 );

        $qb->where($qb->expr()->eq('u.enabled',':enabled'))
            ->setParameter('enabled',true)
            ->andWhere($qb->expr()->eq('u.blocked',':blocked'))
            ->setParameter('blocked',false)
            ->andWhere($qb->expr()->eq('u.hasCard',':hasCard'))
            ->setParameter('hasCard',true)
            ->andWhere($qb->expr()->eq('u.hasStores',':hasStores'))
            ->setParameter('hasStores',true);

        $qb->select('MONTH(u.createdAt) AS gDmonth, YEAR(u.createdAt) AS gDyear, SUM(u.paymentAmount) as income, COUNT(u.id) as _count');
        $qb->addGroupBy('gDmonth')
            ->addGroupBy('gDyear');

        $qb->orderBy('gDyear','ASC');
        $qb->addOrderBy('gDmonth','ASC');

        $qb->andWhere($qb->expr()->gte('u.createdAt',':date'))
            ->setParameter('date',$date);

        $items = $qb->getQuery()->getResult();

        $incomeDays = [];
        foreach ($items as $item)
            $incomeDays[$mois[$item['gDmonth']-1].' '.$item['gDyear']] = [
                'income'    => $item['income'],
                'total'     => $item['_count']
            ];

        $return = [];
        foreach ($incomeDays as $month => $item)
        {
            $return[] = [
                'day'       => $month,
                'text'     => number_format($item['income'],2)." €",
                'income'    => round($item['income'], 2),
                'total'     => $item['total']
            ];
        }

        return $return;
    }

    /**
     * @return array
     */
    public function getUsersWithUpdateToClean()
    {
        $qb = $this->createQueryBuilder('u');
        $qb
            ->where($qb->expr()->lte('u.lastStoresUpdate',':maxLastStoresUpdate'))
            ->leftJoin('u.stores', 's')
            ->setParameter('maxLastStoresUpdate', (new \DateTime('now'))->sub(new \DateInterval('PT12H')))
            ->andWhere($qb->expr()->eq('s.validated',':validated'))
            ->setParameter('validated',true)
            ->andWhere('u.processStoresUpdate = 1');
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersFeesProcessToClean()
    {
        $qb = $this->createQueryBuilder('u');
        $qb
            ->where($qb->expr()->lte('u.lastFeesDate',':lastFeesDate'))
            ->setParameter('lastFeesDate', (new \DateTime('now'))->sub(new \DateInterval('PT48H')))
            ->andWhere('u.processFees = 1');
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersProductsProcessToClean()
    {
        $qb = $this->createQueryBuilder('u');
        $qb
            ->where($qb->expr()->lte('u.lastProductsUpdateDate',':lastProductsUpdateDate'))
            ->setParameter('lastProductsUpdateDate', (new \DateTime('now'))->sub(new \DateInterval('PT72H')))
            ->andWhere('u.processProducts = 1');
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersReviewsProcessToClean()
    {
        $qb = $this->createQueryBuilder('u');
        $qb
            ->where($qb->expr()->lte('u.lastProcessReviewsExecutionDate',':lastProcessReviewsExecutionDate'))
            ->setParameter('lastProcessReviewsExecutionDate', (new \DateTime('now'))->sub(new \DateInterval('PT72H')))
            ->andWhere('u.processReviews = 1');
        ;
        return $qb->getQuery()->getResult();
    }


    /**
     * @return array
     */
    public function getUsersFeedbacksProcessToClean()
    {
        $qb = $this->createQueryBuilder('u');
        $qb
            ->where($qb->expr()->lte('u.lastFeedbacksUpdate',':lastFeedbacksUpdate'))
            ->setParameter('lastFeedbacksUpdate', (new \DateTime('now'))->sub(new \DateInterval('PT72H')))
            ->andWhere('u.processFeedbacks = 1');
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersInventoryProcessToClean()
    {
        $qb = $this->createQueryBuilder('u');
        $qb
            ->where($qb->expr()->lte('u.lastInventoryUpdate',':lastInventoryUpdate'))
            ->setParameter('lastInventoryUpdate', (new \DateTime('now'))->sub(new \DateInterval('PT72H')))
            ->andWhere('u.processInventory = 1');
        ;
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getUsersToClean()
    {
        $lastDate = (new \DateTime('now'))->sub(new \DateInterval('P60D'));
        $qb = $this->createQueryBuilder('u');
        $qb
            ->andWhere(
                $qb->expr()->orX(
                    $qb->expr()->isNull('u.lastStoresUpdate'),
                    $qb->expr()->lt('u.lastStoresUpdate',':lastDate')
                )
            )
            ->andWhere('u.blocked = 1')
            ->andWhere('u.isDeleted = 0')
            ->setParameter('lastDate', $lastDate)
        ;

        return $qb->getQuery()->getResult();
    }

}
